<template>
  <v-form>
    <v-container fluid>
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.code"
            :error-messages="codeErrors"
            :label="$t('Code')"
            @input="$v.item.code.$touch()"
            @blur="$v.item.code.$touch()"
          />
        </v-col>

        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.comment"
            :error-messages="commentErrors"
            :label="$t('Commentaire')"
            step="0.1"
            @input="$v.item.comment.$touch()"
            @blur="$v.item.comment.$touch()"
          />
        </v-col>
      </v-row>

      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model.number="item.sold"
            :error-messages="soldErrors"
            :label="$t('Réduction')"
            @input="$v.item.sold.$touch()"
            @blur="$v.item.sold.$touch()"
          />
        </v-col>
      </v-row>

      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-checkbox
            v-model="item.isPercent"
            :error-messages="isPercentErrors"
            :label="$t('Pourcentage ?')"
            @input="$v.item.isPercent.$touch()"
            @blur="$v.item.isPercent.$touch()"
          />
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script>
import has from "lodash/has";
import { validationMixin } from "vuelidate";
//import { required } from 'vuelidate/lib/validators';

export default {
  name: "AdminPromoCodeForm",
  mixins: [validationMixin],
  props: {
    values: {
      type: Object,
      required: true
    },

    errors: {
      type: Object,
      default: () => {}
    },

    initialValues: {
      type: Object,
      default: () => {}
    },

    isLoading: {
      type: Boolean
    }
  },
  data() {
    return {
      code: null,
      comment: null,
      sold: null,
      isPercent: null,
      company: null
    };
  },
  computed: {
    // eslint-disable-next-line
    item() {
      return this.initialValues || this.values;
    },

    codeErrors() {
      const errors = [];

      if (!this.$v.item.code.$dirty) return errors;

      has(this.violations, "code") && errors.push(this.violations.code);

      return errors;
    },
    commentErrors() {
      const errors = [];

      if (!this.$v.item.comment.$dirty) return errors;

      has(this.violations, "comment") && errors.push(this.violations.comment);

      return errors;
    },
    soldErrors() {
      const errors = [];

      if (!this.$v.item.sold.$dirty) return errors;

      has(this.violations, "sold") && errors.push(this.violations.sold);

      return errors;
    },
    isPercentErrors() {
      const errors = [];

      if (!this.$v.item.isPercent.$dirty) return errors;

      has(this.violations, "isPercent") &&
        errors.push(this.violations.isPercent);

      return errors;
    },
    violations() {
      return this.errors || {};
    }
  },
  validations: {
    item: {
      code: {},
      comment: {},
      sold: {},
      isPercent: {}
    }
  }
};
</script>